#include <stdio.h>
#include <synch.h>
#include <thread.h>

sema_t emptybuf_sem, fullbuf_sem;
#define BSIZE 512

/* double buffer */
struct {
  char data[BSIZE];
  int size;
} buf[2];

void *reader(j)
void *j;
{ int i=0;
  write(2,"start reader\n",13);
  while(1) {
    sema_wait(&emptybuf_sem);
    write(2,"reader 1\n",9);
    buf[i].size = read(0,buf[i].data,BSIZE);
    sema_post(&fullbuf_sem);
    write(2,"reader 2\n",9);
    if (buf[i].size <=0 ) break;
    i ^= 1;
  }
  return (j);
}

void *writer(k)
void *k;
{
  int i=0;

  write(2,"start writer\n",13);
  while (1) {
    sema_wait(&fullbuf_sem);
    write(2,"writer 1\n",9);
    if (buf[i].size <=0) break;
    write(1,buf[i].data,buf[i].size);
    sema_post(&emptybuf_sem);
    write(2,"writer 2\n",9);
    i ^= 1;
  }
  return k;
}
int main()
{
  thread_t twriter;
  int r;

  thr_setconcurrency(2);
  sema_init(&emptybuf_sem,2,0,NULL);
  sema_init(&fullbuf_sem,0,0,NULL);
  write(2,"start\n",6);
  r= thr_create(NULL,0,reader,NULL,
                THR_DETACHED, NULL);
  write(2,"1\n",2);
  r= thr_create(NULL,0,writer,NULL,0l,&twriter);
  write(2,"2\n",2);
  thr_join(twriter, NULL,NULL);
  write(2,"ende\n",5);
}
