
typedef unsigned int thread_t;
typedef unsigned int thread_key_t;

#define	THR_MIN_STACK	thr_min_stack()
/*
 * thread flags (one word bit mask)
 */
#define	THR_BOUND		0x00000001
#define	THR_NEW_LWP		0x00000002
#define	THR_DETACHED		0x00000040
#define	THR_SUSPENDED		0x00000080
#define	THR_DAEMON		0x00000100

int	thr_create(void *, size_t, void *(*)(void *), void *, long, thread_t *);
int	thr_join(thread_t, thread_t *, void **);
int	thr_setconcurrency(int);
int	thr_getconcurrency(void);
void	thr_exit(void *);
thread_t	thr_self();
int		thr_sigsetmask(int, const sigset_t *, sigset_t *);
int		thr_kill(thread_t, int);
int		thr_suspend(thread_t);
int		thr_continue(thread_t);
void		thr_yield(void);
int		thr_setprio(thread_t, int);
int		thr_getprio(thread_t, int *);
int		thr_keycreate(thread_key_t *, void(*)(void *));
int		thr_setspecific(thread_key_t, void *);
int		thr_getspecific(thread_key_t, void **);
size_t		thr_min_stack(void);
#define	THR_MIN_STACK	thr_min_stack()

