/* s_sock1.c  - Server for tcp-socket */

#ifdef SUN
#include "../pthread_sol2.7.h"
#endif
#include "inet.h"
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

pthread_t       threadread, threadwrite;

/* read from 0 and write to socket */
void *talkread(int *sockfd)
{ 
   int n;
   char spid[128]; int lspid;
   char sendline[MAXLINE];

   sprintf(spid,"%d - ",getpid());
   lspid=strlen(spid);
   while (write(1,spid,lspid),write(1,"s: ",3),
          (n=read(0,sendline, MAXLINE)) > 0) {
      if (write(*sockfd,sendline,n) !=n)break;
   }
   pthread_cancel(threadwrite);
   n=0;
   pthread_exit(&n);
}
/* write to 1 and read from socket */
void *talkwrite(int *sockfd)
{ 
   int n;
   char spid[128]; int lspid;
   char sendline[MAXLINE];

   sprintf(spid,"%d - ",getpid());
   lspid = strlen(spid);
   while (1) {
           if ((n=read(*sockfd,sendline,MAXLINE)) <= 0) break;
           write(1,"\n",1);
           write(1,sendline,n);
           write(1,spid,lspid);
           write(1,"S: ",3);
   }
   pthread_cancel(threadread);
   n=0;
   pthread_exit(&n);
}

int main(int argc,char *argv[])
{
   int sockfd, newsockfd, clilen, childpid;
   struct sockaddr_in  cli_addr, serv_addr;
        int i;

   if ((sockfd=socket(AF_INET,SOCK_STREAM,0))<0){
      fprintf(stderr, "server: can't open stream socket\n");
      exit(-1);
   }
   bzero((char *)&serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = htonl(INADDR_ANY); 
   serv_addr.sin_port = htons(SERV_TCP_PORT);
   if ((i=bind(sockfd, (struct sockaddr *) &serv_addr,
                        sizeof(serv_addr))) < 0){
      fprintf(stderr, "server: can't bind local address: %d\n",i);
      exit(-2);
   }
   listen(sockfd,5);
   for (;;) {
      clilen = sizeof(cli_addr);
      newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
      if  (newsockfd < 0){
         fprintf(stderr,"server: accept error\n");
         exit(-3);
      }
      pthread_create(&threadread, NULL,
                     (void *) talkread,
                     (void *) &newsockfd);
      pthread_create(&threadwrite, NULL,
                     (void *) talkwrite,
                     (void *) &newsockfd);

      pthread_join(threadread, NULL);
      pthread_join(threadwrite, NULL);
      write(1,"\nconnection down\n",17);
      close(newsockfd);
   }
}
